<?PHP
//	PWDL:        " PHP WebDevelopment Library "
//	Autor:       " Oliver Keller "
//  Name:        " Younik Network " 
//  Reference:   " http://www.younik.net " 
//	Date:        " 12.04.2006 "
//	Version:     " Revision 1.1 " 


	/*	sendMail - Class overview:
	 *		onLoad, following variables will be gathered form 
	 *		... the post array:
	 *			- from	-> sender
	 *			- rcpt	-> recipient
	 *			- subj	-> subject
	 *			- mesg	-> message
	 *		... the file array:
	 *			- file	-> attachment
	 *
	 *		- send()										// send mail
	 *		- direct_mesg(string, string, string, string)	// sender, recipient, subject, message
	 *	
	 *		- set_type(integer)								// 1 for plain text mail, default 2 (html mail)
	 *		- set_label(string)								// set bottom lable
	 */
	 

	class sendMail {
	
	//	initialization		-----------------------------------------------------------------------------
	
		function sendMail() {
			$this->from = $_POST['from'];
			$this->rcpt = $_POST['rcpt'];
			$this->subj = $_POST['subj'];
			$this->mesg = $_POST['mesg'];
			
			$this->default_settings();
		}
		
		
	//	action		-----------------------------------------------------------------------------
		
		function send() {
			if (1 < strpos($this->from, '@') && 1 < strpos($this->rcpt, '@')) {
				if ($this->type == 1) {
					$this->pl_mail();
				} else {
					$this->html_mail();
				}
			}
		}

		function direct_mesg($from, $rcpt, $subj, $mesg) {
			if (1 < strpos($from, '@') && 1 < strpos($rcpt, '@')) {
				$this->from = $from;
				$this->rcpt = $rcpt;
				$this->subj = $subj;
				$this->mesg = $mesg;
				
				$this->html_mail();
			}
		}

		
	//	send message		-----------------------------------------------------------------------------
				
		function pl_mail() {			
			$this->get_sender();
			if (mail($this->rcpt, $this->subj, $this->mesg, $this->from)) {
				$this->success = 1;
			}
		}	
		
		function html_mail() {
			$this->get_sender();
			$this->get_message();
			$this->get_header();
			if (mail($this->rcpt, $this->subj, $this->mesg, $this->headers)) {
				$this->success = 1;
			}
		}	
		
		
	//	message contents		-----------------------------------------------------------------------------

		function get_sender() {
			//  extract name from whole e-mail address
			$this->name  = substr($this->from, 0, strpos($this->from, "@"));
			$this->from  = "From: ".$this->name." <".$this->from."> \n";
		}
		
		function get_message() {
			// create message in html format
			$this->head    = "<html><head><title>Send Mail</title>";
			$this->head   .= "<style type='text/css'>a:link {color: #444444; text-decoration: none; } a:visited {color: #444444;} a:hover {color: #0000cc;} a:active {color: #0000cc;} .ok{font-size:14px}</style>";
			$this->head   .= "</head><body><table><tr><td></td></tr><tr><td>";
			$this->finish  = "<br><br><br>_________________________________________________________________________<br>";
			$this->finish .= "<span class='ok'>" . $this->label . "</span><br><br>";  
			$this->bottom  = "<br><br></td></tr></table></body></html>";
			// replacement
			$this->mesg  = ereg_replace ("\n", "<br>", $this->mesg);
			// final message
			$this->mesg  = $this->head.$this->mesg.$this->finish.$this->bottom;
		}
		
		function get_header() {
			// file variables
			$tmp_name  = $_FILES['file']['tmp_name'];
			$file_type = $_FILES['file']['type'];
			$file_name = $_FILES['file']['name'];
				
			// if attachment, MIME-Mail:
			if (isset($file_name) && trim($file_name) != "") {
				// read and encode file:
				$datei_content = fread(fopen($tmp_name,"r"),filesize($tmp_name));
				$datei_content = chunk_split(base64_encode($datei_content),76,"\n");
				// Boundary:
				$boundary = md5(uniqid(rand()));
				// Mail-Header:
				$this->headers  = $this->from;
				$this->headers .= "MIME-Version: 1.0\n";
				$this->headers .= "Content-Type: multipart/mixed; boundary=\"".$boundary."\"\n";
				$this->headers .= "This is a multi-part message in MIME format.\n";
				// Mail-Text:
				$this->headers .= "--".$boundary;
				$this->headers .= "\nContent-type: text/html; charset=iso-8859-1";
				$this->headers .= "\n\n".$this->mesg;
				// Attachment:
				$this->headers .= "\n--".$boundary;
				$this->headers .= "\nCache-Control: must-revalidate, post-check=0, pre-check=0";
				$this->headers .= "\nContent-Type: ".$file_type."; name='".$file_name."'";
				$this->headers .= "\nContent-Transfer-Encoding: base64";
				$this->headers .= "\nContent-Disposition: attachment; filename='".$file_name."'";
				$this->headers .= "\n\n".$datei_content;
				// End:
				$this->headers .= "\n--".$boundary."--";  
			// if file error
			} else {
				$this->headers  = "MIME-Version: 1.0 \n";
				$this->headers .= "Content-type: text/html; charset=iso-8859-1 \n";
				$this->headers .= $this->from;
			}
		}


	//	settings		-----------------------------------------------------------------------------

		function default_settings() {
			$this->label   = "sendMail &nbsp; provided by &nbsp; <a href='http://www.younik.net/'>younik.net</a>";
			$this->success = 0;
			$this->type    = 2;
		}
		
		function set_type($type) {
			$this->type = $type;
		}

		function set_label($label) {
			$this->label = $label;
		}
	}
?>